


#ifndef CMSL_H
#define CMSL_H


#include <iostream.h>


#include "CMslkit.h"
#include "CMwk.h"


class CMsl
{
private:
	unsigned char mwkcnt;		//number of wavekits
	CMslkit wavekit[256];		//all wavekits
	unsigned short smpcnt;		//number of samples
	CSample samples[2048];		//all tones

public:
	CMsl();
	~CMsl();

	int init();	//initialise
	int kill();	//destroy

	int Load(char *filename);	//load specifed .MSL file
	int Save(char *filename);	//save to specified .MSL file

	char* ConvertName(char *filename); //convert filename to 11 character sized name

	int AddSample(CSample &sample);	//add a sample

	int Merge(CMsl *msl);	//merge specified .MSL with this file
	int Merge(char *filename);	//merge specified .MWK with this file

	CMwk Extract(char *filename);	//extract an .mwk file from the library

	int Remove(char *filename);	//remove .mwk file from library

	friend ostream& operator<<(ostream &out, CMsl &msl);
	friend CMsl& operator>>(istream &in, CMsl &msl);
};




#endif
