


#ifndef CMSLKIT_H
#define CMSLKIT_H


#include <iostream.h>
#include "CPatch.h"
#include "CToneHeader.h"


class CMslkit
{
private:
	char name[12];			//name WITHOUT dot

	unsigned char tonecnt;	//number of tones used by this kit
	int tones[64];			//samples used by this kit
	CToneHeader th[64];		//headers for all samples

	unsigned char patchcnt;	//number of patches used by this kit
	CPatch patches[48];		//all the patches

public:
	CMslkit();
	~CMslkit();

	int init();
	int kill();

	void SetName(char *n);
	char *GetName();

	void SetPatch(int p, CPatch &patch);

	void SetSampleIndex(int s, int i);
	void SetToneHeader(int t, CToneHeader &th);

	friend ostream& operator<<(ostream &out, CMslkit &kit);
	friend CMslkit& operator>>(istream &in, CMslkit &kit);
};




#endif
