


#ifndef CMWK_H
#define CMWK_H

#include <iostream.h>

#include "CPatch.h"
#include "CTone.h"


class CMwk
{
private:
	unsigned char tonecnt;	//number of tones in .MWK file
	unsigned char patchcnt;	//number of patches in .MWK file
	bool fail;			//true if loading failed

	CPatch patches[48];	//all the instruments
	CTone tones[64];	//all the tones

public:
	CMwk();	
	~CMwk();	

	int init();		//initialise
	int kill();		//destroy

	int Load(char *filename);	//load specified filename
	int Save(char *filename);	//save to mwk file

	bool Failed();		//check if loading failed

	int GetPatchCnt();
	int GetToneCnt();
	
	CPatch GetPatch(int p);
	CTone GetTone(int t);

	friend ostream& operator<<(ostream &out, CMwk &mwk);
	friend CMwk& operator>>(istream &in, CMwk &mwk);

};








#endif
