

#include "CPatch.h"



CPatch::CPatch()
{
	//default patch is used in .MWK file, so it always has 8 waves!
	wavecnt = 8;
}


CPatch::~CPatch()
{


}


int CPatch::GetWaveCount()
{
	return wavecnt;
}


void CPatch::CorrectMsl()
{
	wavecnt = 1;

	while( (waves[wavecnt-1].GetEnd() < 0x060))
		wavecnt++;
}


void CPatch::CorrectMwk()
{
	wavecnt = 8;
}


ostream& operator<<(ostream &out, CPatch &patch)
{

	//output transpose settings
	out.write(&patch.transpose, 1);

	//output all waves
	for (int w = 0; w < patch.wavecnt; w++)
		out << patch.waves[w];

	return out;
}



CPatch& operator>>(istream &in, CPatch &patch)
{
	//read transpose setting
	in.read(&patch.transpose, 1);

	for (int w = 0; w < patch.wavecnt; w++)
		in >> patch.waves[w];

	return patch;
}