


#ifndef CPATCH_H
#define CPATCH_H


#include <iostream.h>


#include "CWave.h"


class CPatch
{
private:
	unsigned char transpose;	//transpose on/off
	int wavecnt;				//number of waves
	CWave waves[8];				//the waves

public:

	CPatch();
	~CPatch();	

	void AddWave(CWave &wave);	//add wave to list

	int GetWaveCount();			//get the number of waves

	void CorrectMsl();		//correct wavecnt for use with MSL files
	void CorrectMwk();		//correct wavecnt for use with MWK files

	CWave& GetWave(int w);		//get specified wave

	

	friend ostream& operator<<(ostream &out, CPatch &patch);
	friend CPatch& operator>>(istream &in, CPatch &patch);
};






#endif
