


#include <string.h>


#include "CSample.h"


CSample::CSample()
{
	length = 0;
	data = NULL;
}


CSample::~CSample()
{
//	if (data)
//		delete data;
}


void CSample::init(unsigned short l, char *d)
{
	length = l;

	if (data)
		delete data;

	data = new char[length];

	memcpy(data, d, length);
}


char* CSample::GetData()
{
	return data;
}


unsigned short CSample::GetLength()
{
	return length;
}


bool CSample::operator==(CSample &sample)
{
	if (sample.length != length)
		return false;

	if (data)
	{
		if (memcmp(sample.data, data, length))
			return false;
	}

	return true;
}


bool CSample::operator!=(CSample &sample)
{
	return !(operator==(sample));
}


CSample& CSample::operator=(CSample &sample)
{
	length = sample.length;

	if (data)
		delete data;

	if (sample.data)
	{
		data = new char[length];

		memcpy(data, sample.data, length);
	}
	else
		data = NULL;

	return *this;
}



int CSample::Write(ostream &out)
{
	out.write(data, length);

	return 0;
}


ostream& operator<<(ostream &out, CSample &sample)
{
	if (sample.length > 0)
	{
		//output sample length
		out.write((char*)&sample.length, 2);

		//output sample data
		out.write(sample.data, sample.length);
	}

	return out;
}


CSample& operator>>(istream &in, CSample &sample)
{
	//read sample length
	in.read((char*)&sample.length, 2);

	//read sample data
	in.read(sample.data, sample.length);

	return sample;
}
