


#include "CTone.h"



CTone::CTone()
{

}


CTone::~CTone()
{

}


void CTone::SetType(unsigned char t)
{
	toneheader.SetType(t);
}


unsigned char CTone::GetType()
{
	return toneheader.GetType();
}


unsigned char CTone::GetFreq()
{
	if (toneheader.GetType() == 1)
		return 1;

	if (toneheader.GetType() == 3)
		return 3;

	if (toneheader.GetType() == 5)
		return 5;

	return 0;
}


CSample CTone::GetSample()
{
	return sample;
}


CToneHeader CTone::GetToneHeader()
{
	return toneheader;
}


bool CTone::operator==(CTone &tone)
{
	if (tone.sample != sample)
		return false;

	if (tone.toneheader != toneheader)
		return false;

	return true;
}


bool CTone::operator!=(CTone &tone)
{
	return !(operator==(tone));
}


CTone& CTone::operator=(CTone &tone)
{
	sample = tone.sample;

	toneheader = tone.toneheader;

	return *this;
}


ostream& operator<<(ostream &out, CTone &tone)
{

	tone.toneheader.Write(out);

	//write sample if tone is not a rom-tone
	if (!(tone.GetType() & 32) )
		tone.sample.Write(out);

	return out;
}


CTone& operator>>(istream &in, CTone &tone)
{
char *data;

	tone.toneheader.Read(in);

	//read sample if tone is not a rom-tone
	if (!(tone.GetType() & 32) )
	{
		data = new char[tone.toneheader.GetSize()];

		in.read(data, tone.toneheader.GetSize());

		tone.sample.init(tone.toneheader.GetSize(), data);

		delete data;
	}

	return tone;
}
