



#ifndef CTONEHEADER_H
#define CTONEHEADER_H


#include <iostream.h>


class CToneHeader
{
private:
	unsigned char type;		//type/frequency

	unsigned short address;	//only used for copied rom tone
	unsigned short loop;
	unsigned short end;

	unsigned char lfo;	//lfo/vib
	unsigned char ar;	//ar/d13
	unsigned char dl;	//dl/d2r
	unsigned char rr;	//rr
	unsigned char am;	//am

	unsigned short size;	//only used for new sample

	unsigned char msb;
public:

	CToneHeader();
	~CToneHeader();

	bool operator==(CToneHeader &th);
	bool operator!=(CToneHeader &th);

	void SetType(unsigned char type);
	unsigned char GetType();

	unsigned short GetSize();

	CToneHeader& operator=(CToneHeader &th);

	//Read/Write operations for use in .MWK files
	int Read(istream &in);
	int Write(ostream &out);

	//overload streaming operators for use in .MSL file
	friend ostream& operator<<(ostream &out, CToneHeader &th);
	friend CToneHeader& operator>>(istream &in, CToneHeader &th);
};



#endif
